-- @author  FIAT80-90DT 
-- @date  	15.11.2011
--
-- ###- ModdingStage - ### - DO NOT EDIT ### --

CouplingPointEvent = {};
CouplingPointEvent_mt = Class(CouplingPointEvent, Event);

InitEventClass(CouplingPointEvent, "CouplingPointEvent");

function CouplingPointEvent:emptyNew()
    local self = Event:new(CouplingPointEvent_mt);
    self.className="CouplingPointEvent";
    return self;
end;

function CouplingPointEvent:new(vehicle, curCouPoint)
    local self = CouplingPointEvent:emptyNew()
    self.vehicle = vehicle;
	self.curCouPoint = curCouPoint;
    return self;
end;

function CouplingPointEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.curCouPoint = streamReadInt8(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function CouplingPointEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt8(streamId, self.curCouPoint);
end;

function CouplingPointEvent:run(connection)
	self.vehicle:setCouplingPoint(self.curCouPoint, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(CouplingPointEvent:new(self.vehicle, self.curCouPoint), nil, connection, self.object);
    end;
end;


function CouplingPointEvent.sendEvent(vehicle, curCouPoint, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(CouplingPointEvent:new(vehicle, curCouPoint), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(CouplingPointEvent:new(vehicle, curCouPoint));
		end;
	end;
end;